# coding: utf-8
import sys
from tkinter import *
from imagecanvas import *
#histogram equalization 
def countRGB():
    L=[0 for j in range(256)]
    for i in range(bitmap.info.width):
        for j in range(bitmap.info.height):
            L[int((tmp[i][j][0]+tmp[i][j][1]+tmp[i][j][2])/3)]+=1
    return L
def setRtable(RGBcount,N):
    print("setRtable enter")
    j=0
    Min=0
    Max=255
    HTotal=0
    Rtable=[0 for j in range(256)]
    for i in range(256):
        HTotal+=RGBcount[i]
        if HTotal>N:
            Min=i
            break
    for i in range(256):
        HTotal+=RGBcount[255-i]
        if HTotal>N:
            Max=255-i
            break
   
    DT=255.0/(Max-Min)
    for i in range(256):
        if i<=Min:
            Rtable[i]=0
        elif i>=Max :
            Rtable[i]=255
        else:
            Rtable[i]=int(DT*(i-Min))
    return Rtable
    
def HistEq():
    N=(bitmap.info.width*bitmap.info.height)/256+1
    RGBcount= countRGB()
    Rtable=setRtable( RGBcount,N)
    NX=bitmap.info.width
    NY=bitmap.info.height
    DX=int(NX/20)   # "処理中"を表示する間隔
    K=1
    for i in range(NX):
        if (i % DX)==0:
            root.title("平坦化処理中"+"■"*K)
            K+=1
        for j in range(NY):
            R=Rtable[tmp[i][j][0]]
            G=Rtable[tmp[i][j][1]]
            B=Rtable[tmp[i][j][2]]
            cbit.Canvas.itemconfig(cbit.ID[i][j],fill=RGB(R,G,B))
    root.update()
    root.title("ヒストグラム平坦化処理完了")
            
#■ウィンドウが閉じられるときの処理
def exitProc():
    if messagebox.askokcancel("終了","終了してもよろしいですか?"):
        root.destroy()
        sys.exit()
#■メイン処理   
root = Tk()
root.geometry("600x500")
root.title("ヒストグラム平坦化処理")
FT=[('BMPファイルlファイル','*.bmp;*.*')]
filename=filedialog.askopenfilename(filetypes=FT)
if filename!="":
    root.title("ビットマップ読込み中")
    bitmap=readBitmap(filename)
    if bitmap!=[]:
        #準備処理
        root.title("キャンバス準備中")
        canvas=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas.place(x=0,y=30)
        canvas2=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas2.place(x=bitmap.info.width,y=30)
        root.title("ビットマップ表示中")
        cbit=drawBitmap(canvas, bitmap)
        root.update()
        root.title("元画像ビットマップ表示中")
        c2=drawBitmap(canvas2, bitmap)
        root.update()
        
        root.title("ビットマップリスト準備中")
        tmp=getRGBList(cbit)
        root.title("ヒストグラム平坦化処理")
        RGBcount=countRGB()
        #ラベルの宣言
        label1 = Label(root, text='処理後', fg='black')
        label1.place(x=10, y=2)
        label2 = Label(root, text='元画像', fg='black')
        label2.place(x=bitmap.info.width+10, y=2)
        #ボタンの宣言                        
        button1 = Button(root, text='終了', command=exitProc)
        button1.place(x=400, y=400)
        button2 = Button(root, text='平坦化処理', command=HistEq)
        button2.place(x=10, y=400)
        
        #メインループ("WM_DELETE_WINDOW"が届いたときexitProcを呼び出す)
        root.protocol("WM_DELETE_WINDOW",exitProc)
        root.mainloop()
root.destroy()
sys.exit()
        
